CREATE TABLE B_CLOUDS_FILE_BUCKET
(
	ID int NOT NULL IDENTITY (1, 1),
	ACTIVE CHAR(1),
	SORT INT,
	READ_ONLY CHAR(1),
	SERVICE_ID VARCHAR(50),
	BUCKET VARCHAR(63),
	LOCATION VARCHAR(50),
	CNAME VARCHAR(100),
	FILE_COUNT INT,
	FILE_SIZE FLOAT,
	LAST_FILE_ID INT,
	PREFIX VARCHAR(100),
	SETTINGS TEXT,
	FILE_RULES TEXT
)
GO
ALTER TABLE B_CLOUDS_FILE_BUCKET ADD CONSTRAINT PK_B_CLOUDS_FILE_BUCKET PRIMARY KEY (ID)
GO
ALTER TABLE B_CLOUDS_FILE_BUCKET ADD CONSTRAINT DF_B_CLOUDS_FILE_BUCKET_ACTIVE DEFAULT 'Y' FOR ACTIVE
GO
ALTER TABLE B_CLOUDS_FILE_BUCKET ADD CONSTRAINT DF_B_CLOUDS_FILE_BUCKET_SORT DEFAULT 500 FOR SORT
GO
ALTER TABLE B_CLOUDS_FILE_BUCKET ADD CONSTRAINT DF_B_CLOUDS_FILE_BUCKET_READ_ONLY DEFAULT 'N' FOR READ_ONLY
GO
ALTER TABLE B_CLOUDS_FILE_BUCKET ADD CONSTRAINT DF_B_CLOUDS_FILE_BUCKETFILE_COUNT DEFAULT 0 FOR FILE_COUNT
GO
ALTER TABLE B_CLOUDS_FILE_BUCKET ADD CONSTRAINT DF_B_CLOUDS_FILE_BUCKETFILE_SIZE DEFAULT 0 FOR FILE_SIZE
GO

CREATE TABLE B_CLOUDS_FILE_UPLOAD
(
	ID VARCHAR(32) NOT NULL,
	TIMESTAMP_X DATETIME NOT NULL,
	FILE_PATH VARCHAR(500) NOT NULL,
	TMP_FILE VARCHAR(500) NULL,
	BUCKET_ID INT NOT NULL,
	PART_SIZE INT NOT NULL,
	PART_NO INT NOT NULL,
	PART_FAIL_COUNTER INT NOT NULL,
	NEXT_STEP VARCHAR(8000)
)
GO
ALTER TABLE B_CLOUDS_FILE_UPLOAD ADD CONSTRAINT PK_B_CLOUDS_FILE_UPLOAD PRIMARY KEY (ID)
GO
CREATE TABLE B_CLOUDS_FILE_RESIZE
(
	ID int NOT NULL IDENTITY (1, 1),
	TIMESTAMP_X DATETIME NOT NULL,
	ERROR_CODE CHAR(1) NOT NULL,
	FILE_ID INT,
	PARAMS VARCHAR(8000),
	FROM_PATH VARCHAR(500),
	TO_PATH VARCHAR(500)
)
GO
ALTER TABLE B_CLOUDS_FILE_RESIZE ADD CONSTRAINT PK_B_CLOUDS_FILE_RESIZE PRIMARY KEY (ID)
GO
ALTER TABLE B_CLOUDS_FILE_RESIZE ADD CONSTRAINT DF_B_CLOUDS_FILE_RESIZE_ERROR_CODE DEFAULT '0' FOR ERROR_CODE
GO
CREATE INDEX IX_B_FILE_RESIZE_TS ON B_CLOUDS_FILE_RESIZE (TIMESTAMP_X)
GO
CREATE INDEX IX_B_FILE_RESIZE_PATH ON B_CLOUDS_FILE_RESIZE (TO_PATH)
GO
CREATE INDEX IX_B_FILE_RESIZE_FILE ON B_CLOUDS_FILE_RESIZE (FILE_ID)
GO
