CREATE TABLE B_CLUSTER_GROUP
(
	ID INT NOT NULL IDENTITY(1,1),
	NAME VARCHAR(50)
)
GO
ALTER TABLE B_CLUSTER_GROUP ADD CONSTRAINT PK_B_CLUSTER_GROUP PRIMARY KEY (ID)
GO

CREATE TABLE B_CLUSTER_DBNODE
(
	ID INT NOT NULL IDENTITY(1,1),
	ACTIVE CHAR(1) NOT NULL,
	GROUP_ID INT,
	ROLE_ID VARCHAR(50),
	NAME VARCHAR(50),
	DESCRIPTION VARCHAR(250),

	DB_HOST VARCHAR(250),
	DB_NAME VARCHAR(250),
	DB_LOGIN VARCHAR(50),
	DB_PASSWORD VARCHAR(50),

	MASTER_ID INT,
	MASTER_HOST VARCHAR(50),
	MASTER_PORT INT,

	SERVER_ID VARCHAR(50),
	STATUS VARCHAR(50),
	UNIQID VARCHAR(50),

	SELECTABLE CHAR(1),
	WEIGHT INT
)
GO
ALTER TABLE B_CLUSTER_DBNODE ADD CONSTRAINT PK_B_CLUSTER_DBNODE PRIMARY KEY (ID)
GO
ALTER TABLE B_CLUSTER_DBNODE ADD CONSTRAINT DF_B_CLUSTER_DBNODE_ACTIVE DEFAULT 'Y' FOR ACTIVE
GO

CREATE TABLE B_CLUSTER_WEBNODE
(
	ID INT NOT NULL IDENTITY(1,1),
	GROUP_ID INT,
	NAME VARCHAR(50),
	DESCRIPTION VARCHAR(250),
	HOST VARCHAR(250),
	PORT INT,
	STATUS_URL VARCHAR(250)
)
GO
ALTER TABLE B_CLUSTER_WEBNODE ADD CONSTRAINT PK_B_CLUSTER_WEBNODE PRIMARY KEY (ID)
GO

CREATE TABLE B_CLUSTER_TABLE
(
	ID INT NOT NULL IDENTITY(1,1),
	TIMESTAMP_X DATETIME,
	MODULE_ID VARCHAR(50),
	TABLE_NAME VARCHAR(50),
	KEY_COLUMN VARCHAR(50),

	FROM_NODE_ID INT,
	TO_NODE_ID INT,
	REC_COUNT INT,
	LAST_ID VARCHAR(250)
)
GO
ALTER TABLE B_CLUSTER_TABLE ADD CONSTRAINT PK_B_CLUSTER_TABLE PRIMARY KEY (ID)
GO

CREATE TABLE B_CLUSTER_QUEUE
(
	ID INT NOT NULL IDENTITY(1,1),
	TIMESTAMP_X DATETIME,
	GROUP_ID INT NOT NULL,
	COMMAND VARCHAR(50),
	PARAM1 VARCHAR(255),
	PARAM2 VARCHAR(255),
	PARAM3 VARCHAR(255)
)
GO
ALTER TABLE B_CLUSTER_QUEUE ADD CONSTRAINT PK_B_CLUSTER_QUEUE PRIMARY KEY (ID)
GO
CREATE INDEX IX_B_CLUSTER_QUEUE_TIME ON B_CLUSTER_QUEUE(TIMESTAMP_X)
GO
CREATE INDEX IX_B_CLUSTER_QUEUE_GROUP ON B_CLUSTER_QUEUE(GROUP_ID)
GO
