CREATE TABLE B_SEARCH_PHRASE
(
	ID			NUMBER(18)	NOT NULL,
	TIMESTAMP_X		DATE		NOT NULL,
	SITE_ID			CHAR(2 CHAR)		NOT NULL,
	RESULT_COUNT		NUMBER(18)		NOT NULL,
	PAGES			NUMBER(18)		NOT NULL,
	SESSION_ID		VARCHAR2(32 CHAR)	NOT NULL,
	PHRASE			VARCHAR2(250 CHAR),
	TAGS			VARCHAR2(250 CHAR),
	URL_TO			VARCHAR2(2000 CHAR),
	URL_TO_404		CHAR(1 CHAR),
	URL_TO_SITE_ID		CHAR(2 CHAR),
	STAT_SESS_ID		NUMBER(18),
	EVENT1			VARCHAR2(50 CHAR),
	CONSTRAINT PK_B_SEARCH_PHRASE PRIMARY KEY (ID)
)
/
CREATE INDEX IND_PK_B_SEARCH_PHRASE_SESS_PH ON b_search_phrase(SESSION_ID, PHRASE)
/
CREATE INDEX IND_PK_B_SEARCH_PHRASE_SESS_TG ON b_search_phrase(SESSION_ID, TAGS)
/
CREATE INDEX IND_PK_B_SEARCH_PHRASE_TIME ON b_search_phrase(TIMESTAMP_X)
/
CREATE SEQUENCE SQ_B_SEARCH_PHRASE
/
CREATE OR REPLACE TRIGGER B_SEARCH_PHRASE_INSERT
BEFORE INSERT
ON B_SEARCH_PHRASE
FOR EACH ROW
BEGIN
	IF :NEW.ID IS NULL THEN
 		SELECT SQ_B_SEARCH_PHRASE.NEXTVAL INTO :NEW.ID FROM DUAL;
	END IF;
END;
/
