CREATE TABLE B_SOCIALSERVICES_USER
(
	ID NUMBER(18) NOT NULL,
	LOGIN VARCHAR2(100 CHAR) NOT NULL,
	NAME VARCHAR2(100 CHAR) NULL,
	LAST_NAME VARCHAR2(100 CHAR) NULL,
	EMAIL VARCHAR2(100 CHAR) NULL,
	PERSONAL_PHOTO NUMBER(18) NULL,
	EXTERNAL_AUTH_ID VARCHAR2(100 CHAR) NOT NULL,
	USER_ID NUMBER(18) NOT NULL,
	XML_ID VARCHAR2(100 CHAR) NOT NULL,
	CAN_DELETE CHAR(1 CHAR) DEFAULT 'Y' NOT NULL,
	PERSONAL_WWW VARCHAR2(100 CHAR) NULL,
	PERMISSIONS VARCHAR2(555 CHAR) NULL,
	OATOKEN VARCHAR2(1000 CHAR) NULL,
	OATOKEN_EXPIRES NUMBER(18) NULL,
	OASECRET VARCHAR2(250 CHAR) NULL,
	REFRESH_TOKEN VARCHAR2(1000 CHAR) NULL,
	SEND_ACTIVITY CHAR(1 CHAR) DEFAULT 'Y' NOT NULL,
	SITE_ID VARCHAR2(50 CHAR) NULL,
	PRIMARY KEY (ID)
)
/

CREATE SEQUENCE SQ_B_SOCIALSERVICES_USER INCREMENT BY 1 NOMAXVALUE NOCYCLE NOCACHE NOORDER
/

CREATE UNIQUE INDEX IX_B_SOCIALSERVICES_USER ON B_SOCIALSERVICES_USER(XML_ID, EXTERNAL_AUTH_ID)
/

CREATE OR REPLACE TRIGGER B_SOCIALSERVICES_USER_INSERT
BEFORE INSERT
ON B_SOCIALSERVICES_USER
FOR EACH ROW
BEGIN
	IF :NEW.ID IS NULL THEN
 		SELECT SQ_B_SOCIALSERVICES_USER.NEXTVAL INTO :NEW.ID FROM dual;
	END IF;
END;
/

CREATE TABLE B_SOCIALSERVICES_MESSAGE
(
	ID NUMBER(18) NOT NULL,
	USER_ID NUMBER(18) NOT NULL,
	SOCSERV_USER_ID NUMBER(18) NOT NULL,
	PROVIDER VARCHAR2(100 CHAR) NOT NULL,
	MESSAGE VARCHAR2(1000 CHAR) NULL,
	INSERT_DATE DATE NULL,
	SUCCES_SENT CHAR(1 CHAR) DEFAULT 'N' NOT NULL ,
	PRIMARY KEY (ID)
)
/
CREATE SEQUENCE SQ_B_SOCIALSERVICES_MESSAGE INCREMENT BY 1 NOMAXVALUE NOCYCLE NOCACHE NOORDER
/
CREATE OR REPLACE TRIGGER B_SOCSERV_MESSAGE_INSERT
BEFORE INSERT
ON B_SOCIALSERVICES_MESSAGE
FOR EACH ROW
BEGIN
	IF :NEW.ID IS NULL THEN
 		SELECT SQ_B_SOCIALSERVICES_MESSAGE.NEXTVAL INTO :NEW.ID FROM dual;
	END IF;
END;
/