CREATE TABLE B_WORKFLOW_DOCUMENT
(
	ID NUMBER(18) NOT NULL,
	STATUS_ID NUMBER(18) NOT NULL,
	DATE_ENTER DATE,
	DATE_MODIFY DATE,
	DATE_LOCK DATE,
	ENTERED_BY NUMBER(18),
	MODIFIED_BY NUMBER(18),
	LOCKED_BY NUMBER(18),
	FILENAME VARCHAR2(255 CHAR) NOT NULL,
	SITE_ID CHAR(2 CHAR),
	TITLE VARCHAR2(255 CHAR),
	BODY CLOB,
	BODY_TYPE VARCHAR2(4 CHAR) DEFAULT 'html' NOT NULL,
	PROLOG CLOB,
	EPILOG CLOB,
	COMMENTS VARCHAR2(2000 CHAR),
	PRIMARY KEY (ID)
)
/
CREATE SEQUENCE SQ_B_WORKFLOW_DOCUMENT
/

CREATE TABLE B_WORKFLOW_FILE
(
	ID NUMBER(18) NOT NULL,
	DOCUMENT_ID NUMBER(18),
	TIMESTAMP_X DATE,
	MODIFIED_BY NUMBER(18),
	TEMP_FILENAME VARCHAR2(255 CHAR),
	FILENAME VARCHAR2(255 CHAR),
	FILESIZE NUMBER(18),
	PRIMARY KEY (ID)
)
/
CREATE UNIQUE INDEX IX_B_WORKFLOW_FILE_TEMP_FILENA ON B_WORKFLOW_FILE(TEMP_FILENAME)
/
CREATE SEQUENCE SQ_B_WORKFLOW_FILE
/

CREATE TABLE B_WORKFLOW_LOG
(
	ID NUMBER(18) NOT NULL,
	DOCUMENT_ID NUMBER(18) NOT NULL,
	TIMESTAMP_X DATE,
	MODIFIED_BY NUMBER(18),
	TITLE VARCHAR2(255 CHAR),
	FILENAME VARCHAR2(255 CHAR),
	SITE_ID CHAR(2 CHAR),
	BODY CLOB,
	BODY_TYPE VARCHAR2(4 CHAR) DEFAULT 'html' NOT NULL,
	STATUS_ID NUMBER(18),
	COMMENTS VARCHAR2(2000 CHAR),
	PRIMARY KEY (ID)
)
/
CREATE INDEX IX_B_WORKFLOW_LOG_DOCUMENT_ID ON B_WORKFLOW_LOG(DOCUMENT_ID)
/
CREATE SEQUENCE SQ_B_WORKFLOW_LOG
/

CREATE TABLE B_WORKFLOW_MOVE
(
	ID NUMBER(18) NOT NULL,
	TIMESTAMP_X DATE NOT NULL,
	DOCUMENT_ID NUMBER(18),
	IBLOCK_ELEMENT_ID NUMBER(18),
	OLD_STATUS_ID NUMBER(18) NOT NULL,
	STATUS_ID NUMBER(18) NOT NULL,
	LOG_ID NUMBER(18),
	USER_ID NUMBER(18),
	PRIMARY KEY (ID)
)
/
CREATE INDEX IX_B_WORKFLOW_MOVE_DOCUMENT_ID ON B_WORKFLOW_MOVE(DOCUMENT_ID)
/
CREATE SEQUENCE SQ_B_WORKFLOW_MOVE
/

CREATE TABLE B_WORKFLOW_PREVIEW
(
	ID NUMBER(18) NOT NULL,
	DOCUMENT_ID NUMBER(18) NOT NULL,
	TIMESTAMP_X DATE,
	FILENAME VARCHAR2(255 CHAR),
	PRIMARY KEY (ID)
)
/
CREATE SEQUENCE SQ_B_WORKFLOW_PREVIEW
/

CREATE TABLE B_WORKFLOW_STATUS
(
	ID NUMBER(18) NOT NULL,
	TIMESTAMP_X DATE,
	C_SORT NUMBER(18) DEFAULT 100,
	ACTIVE CHAR(1 CHAR) DEFAULT 'Y' NOT NULL,
	TITLE VARCHAR2(255 CHAR) NOT NULL,
	DESCRIPTION VARCHAR2(2000 CHAR),
	IS_FINAL CHAR(1 CHAR) DEFAULT 'N' NOT NULL,
	NOTIFY CHAR(1 CHAR) DEFAULT 'Y' NOT NULL,
	PRIMARY KEY (ID)
)
/
CREATE SEQUENCE SQ_B_WORKFLOW_STATUS
/

CREATE TABLE B_WORKFLOW_STATUS2GROUP
(
	ID NUMBER(18) NOT NULL,
	STATUS_ID NUMBER(18) NOT NULL,
	GROUP_ID NUMBER(18) NOT NULL,
	PERMISSION_TYPE NUMBER(18) NOT NULL,
	PRIMARY KEY (ID)
)
/
CREATE INDEX IX_B_WORKFLOW_STATUS_STATUS_ID ON B_WORKFLOW_STATUS2GROUP(STATUS_ID)
/
CREATE SEQUENCE SQ_B_WORKFLOW_STATUS2GROUP
/
